#pragma once

#include "DrawingShape.h"
#include "NPCommonUI.h"
#include "Layout.h"
#include <memory>
#include "ImageProxy.h"
#include "ScriptletContainerFactory.h"

class NPCOMMONUI_API C8ImageFrameDraw	: public CDrawingShape
{
public:
	DECLARE_RTTI;

	DECLARE_COMPONENT_CREATOR(C8ImageFrameDraw);
	C8ImageFrameDraw();
	virtual ~C8ImageFrameDraw(void);

	void GetRectDrawDest(LPRECT prcDrawDest);

	void SetBackground(COLORREF clrBack) { m_clrBg = clrBack; }
	void SetLeftTopImage(IImage* pImage) { m_pImage_LeftTop = std::auto_ptr<IImage>(pImage); }
	void SetCenterTopImage(IImage* pImage) { m_pImage_CenterTop = std::auto_ptr<IImage>(pImage); }
	void SetRightTopImage(IImage* pImage) { m_pImage_RightTop = std::auto_ptr<IImage>(pImage); }
	void SetLeftVCenterImage(IImage* pImage) { m_pImage_LeftVCenter = std::auto_ptr<IImage>(pImage); }
	void SetRightVCenterImage(IImage* pImage) { m_pImage_RightVCenter = std::auto_ptr<IImage>(pImage); }
	void SetLeftBottomImage(IImage* pImage) { m_pImage_LeftBottom = std::auto_ptr<IImage>(pImage); }
	void SetCenterBottomImage(IImage* pImage) { m_pImage_CenterBottom = std::auto_ptr<IImage>(pImage); }
	void SetRightBottomImage(IImage* pImage) { m_pImage_RightBottom = std::auto_ptr<IImage>(pImage); }

	//override
	LPCTSTR GetClassName() { return SCRIPTLET_8IMAGEFRAMEDRAW_NODE; }
	//CContainer
	void DrawComponent(HDC hDC);
	BOOL GetOrginPreferredSize(LPSIZE lpSize);

	void SetBackgroundMargin(LPRECT margin)
	{
		CopyRect(&m_MarginBackground, margin);
	}
private:
	std::auto_ptr<IImage> m_pImage_LeftTop;
	std::auto_ptr<IImage> m_pImage_CenterTop;
	std::auto_ptr<IImage> m_pImage_RightTop;
	std::auto_ptr<IImage> m_pImage_LeftVCenter;
	std::auto_ptr<IImage> m_pImage_RightVCenter;
	std::auto_ptr<IImage> m_pImage_LeftBottom;
	std::auto_ptr<IImage> m_pImage_CenterBottom;
	std::auto_ptr<IImage> m_pImage_RightBottom;
	COLORREF m_clrBg;
	RECT m_MarginBackground;
};
